DevExtreme v24.2 is now available.

Explore our newest features/capabilities and share your thoughts with us.

Your search did not match any results.

JavaScript/jQuery Charts - Export Several Charts

The DevExpress.viz.exportWidgets(widgetInstances, options) method allows you to export several charts to a single image or document.

The widgetInstances parameter accepts an array with the following format:

[
    [ widgetInstance0_1, widgetInstance0_2, ..., widgetInstance0_N ],
    [ widgetInstance1_1, widgetInstance1_2, ..., widgetInstance1_M ],
    ...
    [ widgetInstanceP_1, widgetInstanceP_2, ..., widgetInstanceP_R ]
]
Backend API
$(() => { const chartInstance = $('#chart').dxChart({ rotated: true, title: 'Olympic Gold Medals in 2008', dataSource: goldMedals, series: { color: '#f3c40b', argumentField: 'country', valueField: 'medals', type: 'bar', label: { visible: true, }, }, legend: { visible: false, }, }).dxChart('instance'); const pieChartInstance = $('#pieChart').dxPieChart({ palette: 'Harmony Light', dataSource: allMedals, title: 'Total Olympic Medals\n in 2008', series: [{ argumentField: 'country', valueField: 'medals', label: { visible: true, connector: { visible: true, }, }, }], }).dxPieChart('instance'); $('#export').dxButton({ icon: 'export', text: 'Export', type: 'default', width: 145, onClick() { DevExpress.viz.exportWidgets([[chartInstance, pieChartInstance]], { fileName: 'chart', format: 'PNG', }); }, }); });
<!DOCTYPE html> <html xmlns="http://www.w3.org/1999/xhtml" lang="en"> <head> <title>DevExtreme Demo</title> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <meta http-equiv="Content-Type" content="text/html; charset=utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" /> <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script> <script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script> <link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/24.2.7/css/dx.light.css" /> <script src="js/dx.all.js"></script> <script src="data.js"></script> <link rel="stylesheet" type="text/css" href="styles.css" /> <script src="index.js"></script> </head> <body class="dx-viewport"> <div class="demo-container"> <div id="chart-demo"> <div class="charts"> <div id="chart"></div> <div id="pieChart"></div> </div> <div class="controls-pane"> <div id="export"></div> </div> </div> </div> </body> </html>
#chart-demo { height: 460px; } .charts { width: 820px; margin: 0 auto; height: 374px; margin-bottom: 40px; font-size: 0; } #chart, #pieChart { width: 395px; height: 100%; display: inline-block; vertical-align: top; } #chart { margin-right: 30px; } .controls-pane { text-align: center; }
const allMedals = [{ country: 'USA', medals: 110, }, { country: 'China', medals: 100, }, { country: 'Russia', medals: 71, }, { country: 'UK', medals: 47, }, { country: 'Australia', medals: 46, }, { country: 'Germany', medals: 41, }, { country: 'France', medals: 41, }, { country: 'South Korea', medals: 31, }]; const goldMedals = [{ country: 'China', medals: 51, }, { country: 'USA', medals: 36, }, { country: 'Russia', medals: 22, }, { country: 'UK', medals: 19, }, { country: 'Germany', medals: 16, }, { country: 'Australia', medals: 14, }, { country: 'South Korea', medals: 13, }, { country: 'France', medals: 7, }];

Each nested array contains component instances that should be in the same row in the exported document. In this demo, chartInstance and pieChartInstance occupy the only row in the document.

The options parameter accepts an object whose fields allow you to configure export properties. In this demo, we specify the fileName and format. Refer to the method description for information on other available fields.

Backend API
<div class="charts">
<dx-chart
id="chart"
[dataSource]="goldMedals"
title="Olympic Gold Medals in 2008"
[rotated]="true"
>
<dxi-chart-series
color="#f3c40b"
type="bar"
argumentField="country"
valueField="medals"
>
<dxo-chart-label [visible]="true"></dxo-chart-label>
</dxi-chart-series>
<dxo-chart-legend [visible]="false"></dxo-chart-legend>
</dx-chart>
<dx-pie-chart
id="pieChart"
[dataSource]="allMedals"
[title]="title"
palette="Harmony Light"
>
<dxi-pie-chart-series argumentField="country" valueField="medals">
<dxo-pie-chart-label [visible]="true">
<dxo-pie-chart-connector [visible]="true"></dxo-pie-chart-connector>
</dxo-pie-chart-label>
</dxi-pie-chart-series>
</dx-pie-chart>
</div>
<div class="controls-pane">
<dx-button
icon="export"
text="Export"
type="default"
[width]="145"
(onClick)="export()"
>
</dx-button>
</div>
import { bootstrapApplication } from '@angular/platform-browser';
import { Component, ViewChild, enableProdMode, provideZoneChangeDetection } from '@angular/core';
import {
DxChartModule, DxPieChartModule, DxChartComponent, DxPieChartComponent, DxButtonModule,
} from 'devextreme-angular';
import { exportWidgets } from 'devextreme/viz/export';
import { Service, Medals } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
let modulePrefix = '';
// @ts-ignore
if (window && window.config?.packageConfigPaths) {
modulePrefix = '/app';
}
@Component({
selector: 'demo-app',
providers: [Service],
templateUrl: `app/app.component.html`,
styleUrls: [`app/app.component.css`],
imports: [
DxChartModule,
DxPieChartModule,
DxButtonModule,
],
})
export class AppComponent {
@ViewChild(DxChartComponent, { static: false }) chart: DxChartComponent;
@ViewChild(DxPieChartComponent, { static: false }) pieChart: DxPieChartComponent;
title = 'Total Olympic Medals\n in 2008';
allMedals: Medals[];
goldMedals: Medals[];
constructor(service: Service) {
this.allMedals = service.getAllMedals();
this.goldMedals = service.getGoldMedals();
}
export() {
const chartInstance = this.chart.instance;
const pieChartInstance = this.pieChart.instance;
exportWidgets([[chartInstance, pieChartInstance]], {
fileName: 'chart',
format: 'PNG',
});
}
}
bootstrapApplication(AppComponent, {
providers: [
provideZoneChangeDetection({ eventCoalescing: true, runCoalescing: true }),
],
});
::ng-deep #chart-demo {
height: 460px;
}
::ng-deep .charts {
width: 820px;
margin: 0 auto;
height: 374px;
margin-bottom: 40px;
font-size: 0;
}
::ng-deep #chart,
#pieChart {
width: 395px;
height: 100%;
display: inline-block;
vertical-align: top;
}
::ng-deep #chart {
margin-right: 30px;
}
::ng-deep .controls-pane {
text-align: center;
}
import { Injectable } from '@angular/core';
export class Medals {
country: string;
medals: number;
}
const allMedals: Medals[] = [{
country: 'USA',
medals: 110,
}, {
country: 'China',
medals: 100,
}, {
country: 'Russia',
medals: 71,
}, {
country: 'UK',
medals: 47,
}, {
country: 'Australia',
medals: 46,
}, {
country: 'Germany',
medals: 41,
}, {
country: 'France',
medals: 41,
}, {
country: 'South Korea',
medals: 31,
}];
const goldMedals: Medals[] = [{
country: 'China',
medals: 51,
}, {
country: 'USA',
medals: 36,
}, {
country: 'Russia',
medals: 22,
}, {
country: 'UK',
medals: 19,
}, {
country: 'Germany',
medals: 16,
}, {
country: 'Australia',
medals: 14,
}, {
country: 'South Korea',
medals: 13,
}, {
country: 'France',
medals: 7,
}];
@Injectable()
export class Service {
getAllMedals(): Medals[] {
return allMedals;
}
getGoldMedals(): Medals[] {
return goldMedals;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
const componentNames = [
'accordion',
'action-sheet',
'autocomplete',
'bar-gauge',
'box',
'bullet',
'button-group',
'button',
'calendar',
'card-view',
'chart',
'chat',
'check-box',
'circular-gauge',
'color-box',
'context-menu',
'data-grid',
'date-box',
'date-range-box',
'defer-rendering',
'diagram',
'draggable',
'drawer',
'drop-down-box',
'drop-down-button',
'file-manager',
'file-uploader',
'filter-builder',
'form',
'funnel',
'gallery',
'gantt',
'html-editor',
'linear-gauge',
'list',
'load-indicator',
'load-panel',
'lookup',
'map',
'menu',
'multi-view',
'nested',
'number-box',
'pagination',
'pie-chart',
'pivot-grid-field-chooser',
'pivot-grid',
'polar-chart',
'popover',
'popup',
'progress-bar',
'radio-group',
'range-selector',
'range-slider',
'recurrence-editor',
'resizable',
'responsive-box',
'sankey',
'scheduler',
'scroll-view',
'select-box',
'slider',
'sortable',
'sparkline',
'speech-to-text',
'speed-dial-action',
'splitter',
'stepper',
'switch',
'tab-panel',
'tabs',
'tag-box',
'text-area',
'text-box',
'tile-view',
'toast',
'toolbar',
'tooltip',
'tree-list',
'tree-map',
'tree-view',
'validation-group',
'validation-summary',
'validator',
'vector-map',
];
window.exports = window.exports || {};
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'@angular/platform-browser-dynamic': {
'esModule': true,
},
'@angular/platform-browser': {
'esModule': true,
},
'@angular/core': {
'esModule': true,
},
'@angular/common': {
'esModule': true,
},
'@angular/common/http': {
'esModule': true,
},
'@angular/animations': {
'esModule': true,
},
'@angular/forms': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'ts': 'npm:plugin-typescript@8.0.0/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
/* @angular */
'@angular/compiler': 'bundles:@angular/compiler.umd.js',
'@angular/platform-browser-dynamic': 'bundles:@angular/platform-browser-dynamic.umd.js',
'@angular/core': 'bundles:@angular/core.umd.js',
'@angular/core/primitives/signals': 'bundles:@angular/core.primitives.signals.umd.js',
'@angular/core/primitives/di': 'bundles:@angular/core.primitives.di.umd.js',
'@angular/common': 'bundles:@angular/common.umd.js',
'@angular/common/http': 'bundles:@angular/common-http.umd.js',
'@angular/platform-browser': 'bundles:@angular/platform-browser.umd.js',
'@angular/platform-browser/animations': 'bundles:@angular/platform-browser.umd.js',
'@angular/forms': 'bundles:@angular/forms.umd.js',
/* devextreme */
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69',
/* devextreme-angular umd maps */
'devextreme-angular': 'bundles:devextreme-angular/devextreme-angular.umd.js',
'devextreme-angular/common/ai-integration': 'bundles:devextreme-angular/devextreme-angular-common-ai-integration.umd.js',
'devextreme-angular/core': 'bundles:devextreme-angular/devextreme-angular-core.umd.js',
'devextreme-angular/common/charts': 'bundles:devextreme-angular/devextreme-angular-common-charts.umd.js',
'devextreme-angular/common/core/animation': 'bundles:devextreme-angular/devextreme-angular-common-core-animation.umd.js',
'devextreme-angular/common/core/environment': 'bundles:devextreme-angular/devextreme-angular-common-core-environment.umd.js',
'devextreme-angular/common/core/events': 'bundles:devextreme-angular/devextreme-angular-common-core-events.umd.js',
'devextreme-angular/common/core/localization': 'bundles:devextreme-angular/devextreme-angular-common-core-localization.umd.js',
'devextreme-angular/common/core': 'bundles:devextreme-angular/devextreme-angular-common-core.umd.js',
'devextreme-angular/common/data/custom-store': 'bundles:devextreme-angular/devextreme-angular-common-data-custom-store.umd.js',
'devextreme-angular/common/data': 'bundles:devextreme-angular/devextreme-angular-common-data.umd.js',
'devextreme-angular/common/export/excel': 'bundles:devextreme-angular/devextreme-angular-common-export-excel.umd.js',
'devextreme-angular/common/export/pdf': 'bundles:devextreme-angular/devextreme-angular-common-export-pdf.umd.js',
'devextreme-angular/common/export': 'bundles:devextreme-angular/devextreme-angular-common-export.umd.js',
'devextreme-angular/common/grids': 'bundles:devextreme-angular/devextreme-angular-common-grids.umd.js',
'devextreme-angular/common': 'bundles:devextreme-angular/devextreme-angular-common.umd.js',
'devextreme-angular/http': 'bundles:devextreme-angular/devextreme-angular-http.umd.js',
'devextreme-angular/core/tokens': 'bundles:devextreme-angular/devextreme-angular-core-tokens.umd.js',
...componentNames.reduce((acc, name) => {
acc[`devextreme-angular/ui/${name}`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}.umd.js`;
acc[`devextreme-angular/ui/${name}/nested`] = `bundles:devextreme-angular/devextreme-angular-ui-${name}-nested.umd.js`;
return acc;
}, {}),
'tslib': 'npm:tslib/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
'zone.js': 'npm:zone.js@0.15.1/bundles/zone.umd.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devexpress-diagram@2.2.29/package.json',
'npm:devexpress-gantt@4.1.69/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line no-console
// System.import('@angular/compiler').catch(console.error.bind(console));
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"@angular/core": {
"version": "21.2.11"
},
"core-js": {
"version": "2.6.12"
},
"typescript": {
"version": "5.9.3"
},
"zone.js": {
"version": "0.15.1"
}
};
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/zone.js@0.15.1/bundles/zone.umd.js"></script>
<script src="https://cdn.jsdelivr.net/npm/reflect-metadata@0.1.13/Reflect.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>
Each nested array contains component instances that should be in the same row in the exported document. In this demo, chartInstance and pieChartInstance occupy the only row in the document.
The options parameter accepts an object whose fields allow you to configure export properties. In this demo, we specify the fileName and format. Refer to the method description for information on other available fields.

Backend API
import React, { useCallback, useRef } from 'react';
import Chart, { Series, Label, Legend } from 'devextreme-react/chart';
import type { ChartRef } from 'devextreme-react/chart';
import PieChart, { Series as PieSeries, Label as PieLabel, Connector } from 'devextreme-react/pie-chart';
import type { PieChartRef } from 'devextreme-react/pie-chart';
import { Button } from 'devextreme-react/button';
import { exportWidgets } from 'devextreme/viz/export';
import { allMedals, goldMedals } from './data.ts';
function App() {
const chartRef = useRef<ChartRef>(null);
const pieChartRef = useRef<PieChartRef>(null);
const onClick = useCallback(() => {
const chart = chartRef.current?.instance();
const pieChart = pieChartRef.current?.instance();
if (!chart || !pieChart) {
return;
}
exportWidgets([[chart, pieChart]], {
fileName: 'chart',
format: 'PNG',
});
}, []);
return (
<div id="chart-demo">
<div className="charts">
<Chart
id="chart"
ref={chartRef}
dataSource={goldMedals}
rotated={true}
title="Olympic Gold Medals in 2008"
>
<Series
type="bar"
argumentField="country"
valueField="medals"
color="#f3c40b"
>
<Label visible={true} />
</Series>
<Legend visible={false} />
</Chart>
<PieChart
id="pieChart"
ref={pieChartRef}
dataSource={allMedals}
palette="Harmony Light"
title={'Total Olympic Medals\n in 2008'}
>
<PieSeries
argumentField="country"
valueField="medals"
>
<PieLabel visible={true}>
<Connector visible={true} />
</PieLabel>
</PieSeries>
</PieChart>
</div>
<div className="controls-pane">
<Button
id="export"
width={145}
icon="export"
text="Export"
type="default"
onClick={onClick}
/>
</div>
</div>
);
}
export default App;
import React, { useCallback, useRef } from 'react';
import Chart, { Series, Label, Legend } from 'devextreme-react/chart';
import PieChart, {
Series as PieSeries,
Label as PieLabel,
Connector,
} from 'devextreme-react/pie-chart';
import { Button } from 'devextreme-react/button';
import { exportWidgets } from 'devextreme/viz/export';
import { allMedals, goldMedals } from './data.js';
function App() {
const chartRef = useRef(null);
const pieChartRef = useRef(null);
const onClick = useCallback(() => {
const chart = chartRef.current?.instance();
const pieChart = pieChartRef.current?.instance();
if (!chart || !pieChart) {
return;
}
exportWidgets([[chart, pieChart]], {
fileName: 'chart',
format: 'PNG',
});
}, []);
return (
<div id="chart-demo">
<div className="charts">
<Chart
id="chart"
ref={chartRef}
dataSource={goldMedals}
rotated={true}
title="Olympic Gold Medals in 2008"
>
<Series
type="bar"
argumentField="country"
valueField="medals"
color="#f3c40b"
>
<Label visible={true} />
</Series>
<Legend visible={false} />
</Chart>
<PieChart
id="pieChart"
ref={pieChartRef}
dataSource={allMedals}
palette="Harmony Light"
title={'Total Olympic Medals\n in 2008'}
>
<PieSeries
argumentField="country"
valueField="medals"
>
<PieLabel visible={true}>
<Connector visible={true} />
</PieLabel>
</PieSeries>
</PieChart>
</div>
<div className="controls-pane">
<Button
id="export"
width={145}
icon="export"
text="Export"
type="default"
onClick={onClick}
/>
</div>
</div>
);
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.tsx';
ReactDOM.render(
<App />,
document.getElementById('app'),
);
export const allMedals = [{
country: 'USA',
medals: 110,
}, {
country: 'China',
medals: 100,
}, {
country: 'Russia',
medals: 71,
}, {
country: 'UK',
medals: 47,
}, {
country: 'Australia',
medals: 46,
}, {
country: 'Germany',
medals: 41,
}, {
country: 'France',
medals: 41,
}, {
country: 'South Korea',
medals: 31,
}];
export const goldMedals = [{
country: 'China',
medals: 51,
}, {
country: 'USA',
medals: 36,
}, {
country: 'Russia',
medals: 22,
}, {
country: 'UK',
medals: 19,
}, {
country: 'Germany',
medals: 16,
}, {
country: 'Australia',
medals: 14,
}, {
country: 'South Korea',
medals: 13,
}, {
country: 'France',
medals: 7,
}];
window.exports = window.exports || {};
window.config = {
transpiler: false,
meta: {
'*.ts': {
loader: 'demo-ts-loader',
},
'*.tsx': {
loader: 'demo-ts-loader',
typescriptOptions: {
jsx: 'react',
},
},
'typescript': {
'exports': 'ts',
},
'anti-forgery': {
loader: 'demo-ts-loader',
},
'react': {
'esModule': true,
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
'zod': {
'esModule': true,
},
'zod-to-json-schema': {
'esModule': true,
},
},
paths: {
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
'loaders:': '../../../../shared/loaders/',
},
defaultExtension: 'js',
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'demo-ts-loader': 'loaders:demo-ts-loader.js',
'demo-ts-shared': 'loaders:demo-ts-shared.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'react': 'npm:react@17.0.2/umd/react.development.js',
'react-dom': 'npm:react-dom@17.0.2/umd/react-dom.development.js',
'prop-types': 'npm:prop-types/prop-types.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-react': 'npm:devextreme-react@link:../../packages/devextreme-react/npm/cjs',
'zod': 'externals:zod.bundle.js',
'zod-to-json-schema': 'externals:zod-to-json-schema.bundle.js',
'devextreme-quill': 'npm:devextreme-quill@1.7.10/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.4/dist/signals-core.min.js',
'devextreme-cldr-data': 'npm:devextreme-cldr-data@1.0.3',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme': {
defaultExtension: 'js',
},
'devextreme-react': {
main: 'index.js',
},
'devextreme-react/common': {
main: 'index.js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/localization/messages': {
format: 'json',
defaultExtension: 'json',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
let packagesInfo = {
"zod": {
"version": "3.24.4"
},
"zod-to-json-schema": {
"version": "3.24.6"
}
};
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(<App />, document.getElementById('app'));
export const allMedals = [
{
country: 'USA',
medals: 110,
},
{
country: 'China',
medals: 100,
},
{
country: 'Russia',
medals: 71,
},
{
country: 'UK',
medals: 47,
},
{
country: 'Australia',
medals: 46,
},
{
country: 'Germany',
medals: 41,
},
{
country: 'France',
medals: 41,
},
{
country: 'South Korea',
medals: 31,
},
];
export const goldMedals = [
{
country: 'China',
medals: 51,
},
{
country: 'USA',
medals: 36,
},
{
country: 'Russia',
medals: 22,
},
{
country: 'UK',
medals: 19,
},
{
country: 'Germany',
medals: 16,
},
{
country: 'Australia',
medals: 14,
},
{
country: 'South Korea',
medals: 13,
},
{
country: 'France',
medals: 7,
},
];
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/26.1.4/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.tsx");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart-demo {
height: 460px;
}
.charts {
width: 820px;
margin: 0 auto;
height: 374px;
margin-bottom: 40px;
font-size: 0;
}
#chart,
#pieChart {
width: 395px;
height: 100%;
display: inline-block;
vertical-align: top;
}
#chart {
margin-right: 30px;
}
.controls-pane {
text-align: center;
}
Each nested array contains component instances that should be in the same row in the exported document. In this demo, chartInstance and pieChartInstance occupy the only row in the document.
The options parameter accepts an object whose fields allow you to configure export properties. In this demo, we specify the fileName and format. Refer to the method description for information on other available fields.

-
AI-powered Extensions
-
Data Grid
-
Tree List
-
Chat
-
HTML Editor
-
Form
-
-
Data Grids / Data Management
-
Data Grid
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Grouping
-
Selection
- Focused Row
- Paging
-
Scrolling
-
Columns
- AI Assistant
-
Master-Detail
-
Data Summaries
-
Drag & Drop
-
Export to PDF
-
Export to Excel
- Appearance
-
Customization
- State Persistence
-
Adaptability
-
Keyboard Navigation
- Right-To-Left Support
-
Tree List
- Overview
-
Data Binding
-
Filtering
- Sorting
-
Editing
-
Selection
- Focused Row
- Paging
-
Columns
- Drag & Drop
- State Persistence
- Adaptability
-
Keyboard Navigation
-
Card View
-
Pivot Grid
- Overview
-
Data Binding
-
Field Management
-
Data Summaries
- Drill Down
- Filtering
-
Scrolling
-
Export to Excel
- Chart Integration
- Customization
- State Persistence
-
Filter Builder
-
-
Data Visualization
-
Charts
- Overview
-
Data Binding
-
Common Concepts
-
Axis
-
Aggregation
-
Tooltips
-
Selection
-
Customization
-
Zooming
-
Export
-
-
Area Charts
-
Bar Charts
- Bullet Charts
-
Doughnut Charts
-
Financial Charts
-
Funnel and Pyramid Charts
-
Line Charts
- Pareto Chart
-
Pie Charts
-
Point Charts
-
Polar and Radar Charts
-
Range Charts
- Sankey Chart
-
Sparkline Charts
-
Tree Map
-
Gauges
- Overview
-
Runtime update
-
Bar Gauge
-
Circular Gauge
-
Linear Gauge
-
Diagram
- Overview
-
Data Binding
-
Featured Shapes
-
Custom Shapes
-
Document Capabilities
-
User Interaction
- UI Customization
- Adaptability
-
-
Scheduling / Planning
-
Scheduler
- Overview
-
Data Binding
-
Views
-
Appointments
-
Timetable
- Editing
-
Grouping
- Virtual Scrolling
- Drag & Drop
-
Customization
- Adaptability
-
Gantt
- Overview
- Data Binding
-
Filtering
- Sorting
- Strip Lines
- Export to PDF
- Validation
-
Customization
-
-
Messaging
-
WYSIWYG Editor
-
Forms
-
Data Editors
- Overview
-
Common Concepts
-
Calendar
- Check Box
- Color Box
-
Date Box
-
Date Range Box
-
Number Box
- Radio Group
-
Range Selector
- Range Slider
- Slider
- Switch
- Text Area
- Text Box
-
Drop-Downs
- Autocomplete
-
Drop Down Box
-
Select Box
-
Tag Box
-
Lookup
-
Buttons
-
File Upload / File Management
-
File Manager
- Overview
-
File System Types
-
Customization
-
File Uploader
-
-
Popup and Notifications
-
Navigation
- Overview
- Accordion
-
Action Sheet
-
Context Menu
-
Menu
- Multi View
-
Drawer
-
Tab Panel
-
Tabs
-
Toolbar
-
Stepper
- Pagination
-
List
-
Tree View
- Right-to-Left Support
-
Layout
-
Tile View
- Splitter
-
Gallery
- Scroll View
- Box
- Responsive Box
-
-
Interactive Wrappers
-
Sortable
- Resizable
-
-
Progress Indicators
-
Maps
- Overview
-
Map
-
Vector Map
-
Data Binding
- Multiple Layers
-
Markers
- Legend
-
Zooming and Panning
-
Customization
-
-
Localization
Related Demos:
Your search did not match any results.
Vue Charts - Export Several Charts
The DevExpress.viz.exportWidgets(widgetInstances, options) method allows you to export several charts to a single image or document.
The widgetInstances parameter accepts an array with the following format:
[
[ widgetInstance0_1, widgetInstance0_2, ..., widgetInstance0_N ],
[ widgetInstance1_1, widgetInstance1_2, ..., widgetInstance1_M ],
...
[ widgetInstanceP_1, widgetInstanceP_2, ..., widgetInstanceP_R ]
]
Backend API
<template>
<div id="chart-demo">
<div class="charts">
<DxChart
id="chart"
ref="chart"
:data-source="goldMedals"
:rotated="true"
title="Olympic Gold Medals in 2008"
>
<DxSeries
type="bar"
argument-field="country"
value-field="medals"
color="#f3c40b"
>
<DxLabel :visible="true"/>
</DxSeries>
<DxLegend :visible="false"/>
</DxChart>
<DxPieChart
id="pieChart"
ref="pieChart"
:data-source="allMedals"
palette="Harmony Light"
:title="'Total Olympic Medals\n in 2008'"
>
<DxPieSeries
argument-field="country"
value-field="medals"
>
<DxPieLabel :visible="true">
<DxConnector :visible="true"/>
</DxPieLabel>
</DxPieSeries>
</DxPieChart>
</div>
<div class="controls-pane">
<DxButton
id="export"
:width="145"
icon="export"
type="default"
text="Export"
@click="onClick()"
/>
</div>
</div>
</template>
<script setup lang="ts">
import { ref } from 'vue';
import DxChart, {
DxSeries,
DxLabel,
DxLegend,
} from 'devextreme-vue/chart';
import DxPieChart, {
DxSeries as DxPieSeries,
DxLabel as DxPieLabel,
DxConnector,
} from 'devextreme-vue/pie-chart';
import { exportWidgets } from 'devextreme/viz/export';
import DxButton from 'devextreme-vue/button';
import { allMedals, goldMedals } from './data.ts';
const chart = ref();
const pieChart = ref();
function onClick() {
const chartInstance = chart.value.instance;
const pieChartInstance = pieChart.value.instance;
exportWidgets([[chartInstance, pieChartInstance]], {
fileName: 'chart',
format: 'PNG',
});
}
</script>
<style>
#chart-demo {
height: 460px;
}
.charts {
width: 820px;
margin: 0 auto;
height: 374px;
margin-bottom: 40px;
font-size: 0;
}
#chart,
#pieChart {
width: 395px;
height: 100%;
display: inline-block;
vertical-align: top;
}
#chart {
margin-right: 30px;
}
.controls-pane {
text-align: center;
}
</style>
window.exports = window.exports || {};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'*.ts': {
loader: 'demo-ts-loader',
},
'*.svg': {
loader: 'svg-loader',
},
'devextreme/time_zone_utils.js': {
'esModule': true,
},
'devextreme/localization.js': {
'esModule': true,
},
'devextreme/viz/palette.js': {
'esModule': true,
},
'openai': {
'esModule': true,
},
},
paths: {
'project:': '../../../../',
'npm:': 'https://cdn.jsdelivr.net/npm/',
'bundles:': '../../../../bundles/',
'externals:': '../../../../bundles/externals/',
'anti-forgery:': '../../../../shared/anti-forgery/',
},
map: {
'anti-forgery': 'anti-forgery:fetch-override.js',
'vue': 'npm:vue@3.5.32/dist/vue.esm-browser.js',
'@vue/shared': 'npm:@vue/shared@3.4.27/dist/shared.cjs.prod.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.1.2/index.js',
'demo-ts-loader': 'project:utils/demo-ts-loader.js',
'jszip': 'npm:jszip@3.10.1/dist/jszip.min.js',
'svg-loader': 'project:utils/svg-loader.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@3.4.4/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign',
'devextreme': 'npm:devextreme@link:../../packages/devextreme/artifacts/npm/devextreme/cjs',
'devextreme-vue': 'npm:devextreme-vue@link:../../packages/devextreme-vue/npm/cjs',
'devextreme-quill': 'npm:devextreme-quill@1.7.9/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.2.29/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.69/dist/dx-gantt.js',
'inferno': 'npm:inferno@8.2.3/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@8.2.3/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras/dist/inferno-extras.min.js',
'@preact/signals-core': 'npm:@preact/signals-core@1.14.1/dist/signals-core.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
// Prettier
'prettier/standalone': 'npm:prettier@2.8.8/standalone.js',
'prettier/parser-html': 'npm:prettier@2.8.8/parser-html.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme-vue/common': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/common/core/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
window.process = {
env: {
NODE_ENV: 'production',
},
};
System.config(window.config);
// eslint-disable-next-line
const useTgzInCSB = ['openai'];
export const allMedals = [{
country: 'USA',
medals: 110,
}, {
country: 'China',
medals: 100,
}, {
country: 'Russia',
medals: 71,
}, {
country: 'UK',
medals: 47,
}, {
country: 'Australia',
medals: 46,
}, {
country: 'Germany',
medals: 41,
}, {
country: 'France',
medals: 41,
}, {
country: 'South Korea',
medals: 31,
}];
export const goldMedals = [{
country: 'China',
medals: 51,
}, {
country: 'USA',
medals: 36,
}, {
country: 'Russia',
medals: 22,
}, {
country: 'UK',
medals: 19,
}, {
country: 'Germany',
medals: 16,
}, {
country: 'Australia',
medals: 14,
}, {
country: 'South Korea',
medals: 13,
}, {
country: 'France',
medals: 7,
}];
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html lang="en">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=5.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/25.2.8/css/dx.light.css" />
<script src="https://cdn.jsdelivr.net/npm/typescript@5.9.3/lib/typescript.js"></script>
<script type="module">
import * as vueCompilerSFC from "https://cdn.jsdelivr.net/npm/@vue/compiler-sfc@3.4.27/dist/compiler-sfc.esm-browser.js";
window.vueCompilerSFC = vueCompilerSFC;
</script>
<script src="https://cdn.jsdelivr.net/npm/core-js@2.6.12/client/shim.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.ts");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
Each nested array contains component instances that should be in the same row in the exported document. In this demo, chartInstance and pieChartInstance occupy the only row in the document.
The options parameter accepts an object whose fields allow you to configure export properties. In this demo, we specify the fileName and format. Refer to the method description for information on other available fields.